<template>
    <div class="content-wrapper">
        <section class="content">
            <div class="container-fluid">
                <div>
                    <h2>Комнания</h2>
                </div>
                <div v-if="lvl >= 2">
                    <!-- Button trigger modal -->
                    <button type="button" class="btn btn-success" data-toggle="modal" data-target="#addUserModal">
                        Добавить
                    </button>

                    <!-- Modal -->
                    <div class="modal fade" id="addUserModal" tabindex="-1" role="dialog" aria-labelledby="addUserModalLabel" aria-hidden="true">
                        <div class="modal-dialog" role="document">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <h5 class="modal-title" id="addUserModalLabel">Добавить Компанию</h5>
                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                        <span aria-hidden="true">&times;</span>
                                    </button>
                                </div>
                                <form @submit.prevent="createNewUser">
                                    <div class="modal-body">
                                        <div class="mb-3">
                                            <label for="company" class="form-label">Имя Компании</label>
                                            <input type="text" class="form-control" id="company" v-model="newUser.company">
                                            <label for="email" class="form-label">Почта</label>
                                            <input type="email" class="form-control" id="email" v-model="newUser.email">
                                            <label for="logo" class="form-label">Логотип</label>
                                            <input type="text" class="form-control" id="logo" v-model="newUser.logo">
                                            <label for="website" class="form-label">Веб-сайт</label>
                                            <input type="text" class="form-control" id="website" v-model="newUser.website">
                                            <label for="address" class="form-label">Адрес</label>
                                            <input type="text" class="form-control" id="address" v-model="newUser.address">
                                        </div>
                                    </div>
                                    <div class="modal-footer">
                                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Закрыть</button>
                                        <button type="submit" class="btn btn-primary">Добавить</button>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
                <table class="table">
                    <thead>
                    <tr>
                        <th>Имя Компании</th>
                        <th>Почта</th>
                        <th>Логотип</th>
                        <th>Веб-сайт</th>
                        <th>Адрес</th>
                        <th v-if="lvl >= 2">Действия</th>
                    </tr>
                    </thead>
                    <UserCardCompany v-for="user in users" :key="user.id" :user="user" :lvl="lvl"/>
                </table>
                <nav aria-label="...">
                    <ul class="pagination">
                        <li class="page-item">
                            <a @click="updatePage(currentPage - 1, $event)"
                               :class="['page-link', {'disabled': currentPage === 1}]"
                               href="#" tabindex="-1" aria-disabled="true">
                                Предыдущая
                            </a>
                        </li>
                        <li class="page-item"
                            :class="{ 'active': page === currentPage }"
                            v-for="page in displayPages"
                            :key="page"
                            v-if="page <= lastPage">
                            <a @click="updatePage(page, $event)"
                               :class="['page-link']"
                               href="#">
                                {{ page }}
                            </a>
                        </li>
                        <li class="page-item">
                            <a @click="updatePage(currentPage + 1, $event)"
                               :class="['page-link', {'disabled': currentPage === lastPage}]"
                               href="#">
                                Следующая
                            </a>
                        </li>
                    </ul>
                </nav>
            </div>
        </section>
    </div>
</template>

<script>
import { mapActions, mapGetters, mapMutations } from "vuex";
import UserCardCompany from "./UserCardCompany.vue";

export default {
    name: "AdminCompany",
    components: {
        UserCardCompany,
    },
    data() {
        return {
            newUser: {
                company: '',
                website: '',
                email: '',
                logo: '',
                address: '',
            }
        }
    },
    computed: {
        ...mapGetters('companies', ['users', 'currentPage', 'lastPage']),
        ...mapGetters('auth', ['lvl']),
        displayPages() {
            const pages = [1];
            const startPage = this.currentPage === 1 ? 1 : this.currentPage;
            const endPage = startPage + 4;

            for (let i = startPage; i <= endPage; i++) {
                if (this.currentPage === 1){
                    pages.push(i + 1);
                } else {
                    pages.push(i);
                }
            }

            return pages;
        }

    },
    methods: {
        ...mapActions('companies',['showUsers', 'addUser']),
        ...mapMutations('companies', ['setCurrentPage']),
        updatePage(page, event) {
            event.preventDefault();
            this.setCurrentPage(page);
            this.showUsers({page: page, typePage: 'companies'});
        },
        async createNewUser() {
            await this.addUser(this.newUser);
            this.newUser =  {
                company: '',
                website: '',
                email: '',
                logo: '',
                address: '',
            };
        }
    },
    mounted() {
        this.showUsers({typePage: 'companies'});
    }
}
</script>
